﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using UOC.SistemaControl.Mobil.ServiceReference1;

namespace UOC.SistemaControl.Mobil
{
    public partial class DispSensors : PhoneApplicationPage
    {
        string sen, ubi;
        public DispSensors()
        {
            InitializeComponent();
            //Carreguem la llista de les ubicacions a l'inici
            Mobil.ServiceReference1.Service1Client ms = new Mobil.ServiceReference1.Service1Client();
            ms.LlistaUbicacionsCompleted += new EventHandler<LlistaUbicacionsCompletedEventArgs>(llistaUbicacions);
            ms.LlistaUbicacionsAsync();
        }

        //Obtenim una llista de les ubicacions 
        void llistaUbicacions(object sender, LlistaUbicacionsCompletedEventArgs e)
        {
            List<DispositiuIluminacio> dI;
            dI = e.Result.ToList();
            foreach (DispositiuIluminacio c in dI)
            {
                llista.Items.Add(c.Descripcio.ToString());
            }
        }

        //Obtenim els sensors que hi han en una ubicació
        private void obtenirSensors(object sender, EventArgs e)
        {
            Mobil.ServiceReference1.Service1Client ms = new Mobil.ServiceReference1.Service1Client();
            string seleccio = llista.SelectedItem.ToString();
            llistaSen.Items.Clear();
            ms.SensorsUbicacioCompleted += new EventHandler<SensorsUbicacioCompletedEventArgs>(llistaSensors);
            ms.SensorsUbicacioAsync(seleccio);
        }

        //Afegim els sensors a la llista
        void llistaSensors(object sender, SensorsUbicacioCompletedEventArgs e)
        {
            List<Sensors> dS;
            dS = e.Result.ToList();
            foreach (Sensors s in dS)
            {
                llistaSen.Items.Add(s.Descripcio.ToString());
            }
        }

        //Obtenim l'estat dels sensors de la ubicació
        private void obtenirEstat(object sender, EventArgs e)
        {
            if (llistaSen.SelectedItem != null)
            {
                Mobil.ServiceReference1.Service1Client ms = new Mobil.ServiceReference1.Service1Client();
                ubi = llista.SelectedItem.ToString();
                sen = llistaSen.SelectedItem.ToString();
                ms.EstatSensorCompleted += new EventHandler<EstatSensorCompletedEventArgs>(estatSensor);
                ms.EstatSensorAsync(sen, ubi);
            }
        }

        //Mostrem en pantalla l'estat del sensor
        void estatSensor(object sender, EstatSensorCompletedEventArgs e)
        {
            if (llistaSen.SelectedItem.ToString() != "Sensor Temperatura" && llistaSen.SelectedItem.ToString() != "Sensor Llum")
            {
                if (e.Result == 1)
                {
                    lblEstat.Text = "Activat";
                }
                else
                {
                    lblEstat.Text = "Desactivat";
                }
            }
            if (llistaSen.SelectedItem.ToString() == "Sensor Temperatura")
                lblEstat.Text = e.Result + " °C";

            if (llistaSen.SelectedItem.ToString() == "Sensor Llum")
                lblEstat.Text = e.Result + " Lux";
        }


        //Botó per tornar al menú principal
        private void button3_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.RelativeOrAbsolute));
        }
    }
}