﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using UOC.SistemaControl.Mobil.ServiceReference1;

namespace UOC.SistemaControl.Mobil
{
    public partial class Il_luminacio : PhoneApplicationPage
    {
        public Il_luminacio()
        {
            InitializeComponent();
            //Carreguem la llista de les ubicacions a l'inici
            Mobil.ServiceReference1.Service1Client ms = new Mobil.ServiceReference1.Service1Client();
            ms.LlistaUbicacionsCompleted += new EventHandler<LlistaUbicacionsCompletedEventArgs>(llistaUbicacions);
            ms.LlistaUbicacionsAsync();
        }

        //Obtenim una llista de les ubicacions 
        void llistaUbicacions(object sender, LlistaUbicacionsCompletedEventArgs e)
        {
            List<DispositiuIluminacio> dI;
            dI = e.Result.ToList();
            foreach (DispositiuIluminacio c in dI)
            {
                llista.Items.Add(c.Descripcio.ToString());
            }
        }

        //Obtenim l'estat del dispositiu d'il·luminació d'una ubicació
        private void obtenirEstat(object sender, EventArgs e)
        {
            string seleccio = llista.SelectedItem.ToString();
            Mobil.ServiceReference1.Service1Client ms = new Mobil.ServiceReference1.Service1Client();
            ms.ObtenirEstatDispositiuCompleted += new EventHandler<ObtenirEstatDispositiuCompletedEventArgs>(estatIluminacio);
            ms.ObtenirEstatDispositiuAsync(seleccio);
        }

        //Mostrem per pantalla l'estat de la il·luminació
        void estatIluminacio(object sender, ObtenirEstatDispositiuCompletedEventArgs e)
        {

            if (e.Result == 1)
            {
                lblEstat.Text = "Activat";
            }
            else
            {
                lblEstat.Text = "Desactivat";
            }
        }

        //Activem la il·luminació d'una ubicació seleccionada
        private void button1_on(object sender, RoutedEventArgs e)
        {
            Mobil.ServiceReference1.Service1Client ms = new Mobil.ServiceReference1.Service1Client();
            string seleccio = llista.SelectedItem.ToString();
            ms.CanviEstatIluminacioCompleted += new EventHandler<CanviEstatIluminacioCompletedEventArgs>(obtenirEstat);
            ms.CanviEstatIluminacioAsync(seleccio, 1);
        }

        //Desactivem la il·luminació d'una ubicació seleccionada
        private void button2_off(object sender, RoutedEventArgs e)
        {
            Mobil.ServiceReference1.Service1Client ms = new Mobil.ServiceReference1.Service1Client();
            string seleccio = llista.SelectedItem.ToString();
            ms.CanviEstatIluminacioCompleted += new EventHandler<CanviEstatIluminacioCompletedEventArgs>(obtenirEstat);
            ms.CanviEstatIluminacioAsync(seleccio, 0);
        }

        //Botó que ens porta al menú principal
        private void button3_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.RelativeOrAbsolute));
        }

    }
}