﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using UOC.SistemaControl.Mobil.ServiceReference1;

namespace UOC.SistemaControl.Mobil.InfoEstats
{
    public partial class E_Entrada : PhoneApplicationPage
    {
        private Grid gridInfo = new Grid();
        int i = 0;

        public E_Entrada()
        {

            InitializeComponent();
            gridInfo.Width = 350;
            gridInfo.Height = 250;
            gridInfo.HorizontalAlignment = HorizontalAlignment.Left;
            gridInfo.VerticalAlignment = VerticalAlignment.Top;
            ColumnDefinition colDispSen = new ColumnDefinition();
            ColumnDefinition colEstat = new ColumnDefinition();
            colDispSen.Width = new GridLength(211, GridUnitType.Pixel);
            colEstat.Width = new GridLength(119, GridUnitType.Pixel);
            gridInfo.ColumnDefinitions.Add(colDispSen);
            gridInfo.ColumnDefinitions.Add(colEstat);
            Mobil.ServiceReference1.Service1Client ms2 = new Mobil.ServiceReference1.Service1Client();
            ms2.SensorsUbicacioCompleted += new EventHandler<SensorsUbicacioCompletedEventArgs>(estatSen);
            ms2.SensorsUbicacioAsync(textBlock1.Text.ToString());
            Mobil.ServiceReference1.Service1Client ms1 = new Mobil.ServiceReference1.Service1Client();
            ms1.ObtenirEstatDispositiuCompleted += new EventHandler<ObtenirEstatDispositiuCompletedEventArgs>(dispIluminacio);
            ms1.ObtenirEstatDispositiuAsync(textBlock1.Text);
        }

        //Obtenim el tipus de sensor i estat corresponent a "Entrada" i l'afegim al grid 
        void estatSen(object sender, SensorsUbicacioCompletedEventArgs e)
        {
            List<Sensors> sen;
            sen = e.Result.ToList();
            int estat;
            foreach (Sensors s in sen)
            {
                RowDefinition sNewRow = new RowDefinition();
                sNewRow.Height = new GridLength(40, GridUnitType.Pixel);
                gridInfo.RowDefinitions.Add(sNewRow);

                TextBlock lblDisSen = new TextBlock();
                lblDisSen.Foreground = new SolidColorBrush(Color.FromArgb(255, 0, 0, 0));
                lblDisSen.Text = s.Descripcio.ToString();
                lblDisSen.HorizontalAlignment = HorizontalAlignment.Left;
                lblDisSen.VerticalAlignment = VerticalAlignment.Center;
                Grid.SetColumnSpan(lblDisSen, 1);
                Grid.SetRow(lblDisSen, i);

                TextBlock lblEstat = new TextBlock();
                lblEstat.Foreground = new SolidColorBrush(Color.FromArgb(255, 0, 0, 0));
                lblEstat.FontWeight = FontWeights.Bold;
                lblEstat.HorizontalAlignment = HorizontalAlignment.Right;
                lblEstat.VerticalAlignment = VerticalAlignment.Center;
                estat = s.Estat;

                if (s.Descripcio != "Sensor Llum" && s.Descripcio != "Sensor Temperatura")
                {
                    if (estat == 1)
                        lblEstat.Text = "Activat";
                    else
                        lblEstat.Text = "Desactivat";
                }
                else
                {
                    if (s.Descripcio == "Sensor Temperatura")
                        lblEstat.Text = estat + " °C";
                    if (s.Descripcio == "Sensor Llum")
                        lblEstat.Text = estat + " Lux";
                }

                Grid.SetColumnSpan(lblEstat, 2);
                Grid.SetRow(lblEstat, i);
                i++;

                gridInfo.Children.Add(lblDisSen);
                gridInfo.Children.Add(lblEstat);

            }


        }

        //Obtenim l'estat de il·luminació a "Entrada" i l'afegim al grid
        void dispIluminacio(object sender, ObtenirEstatDispositiuCompletedEventArgs e)
        {
            RowDefinition sNewRow = new RowDefinition();
            sNewRow.Height = new GridLength(40, GridUnitType.Pixel);
            gridInfo.RowDefinitions.Add(sNewRow);

            TextBlock lblDisSen = new TextBlock();
            lblDisSen.Foreground = new SolidColorBrush(Color.FromArgb(255, 0, 0, 0));
            lblDisSen.Text = "Il·luminació";
            lblDisSen.HorizontalAlignment = HorizontalAlignment.Left;
            lblDisSen.VerticalAlignment = VerticalAlignment.Center;
            Grid.SetColumnSpan(lblDisSen, 1);
            Grid.SetRow(lblDisSen, i);
            gridInfo.Children.Add(lblDisSen);

            if (e.Result == 1)
            {
                TextBlock lblEstat = new TextBlock();
                lblEstat.Foreground = new SolidColorBrush(Color.FromArgb(255, 0, 0, 0));
                lblEstat.FontWeight = FontWeights.Bold;
                lblEstat.HorizontalAlignment = HorizontalAlignment.Right;
                lblEstat.VerticalAlignment = VerticalAlignment.Center;
                lblEstat.Text = "Activat";
                Grid.SetColumnSpan(lblEstat, 2);
                Grid.SetRow(lblEstat, i);
                gridInfo.Children.Add(lblEstat);
            }
            else
            {
                TextBlock lblEstat = new TextBlock();
                lblEstat.Foreground = new SolidColorBrush(Color.FromArgb(255, 0, 0, 0));
                lblEstat.FontWeight = FontWeights.Bold;
                lblEstat.HorizontalAlignment = HorizontalAlignment.Right;
                lblEstat.VerticalAlignment = VerticalAlignment.Center;
                lblEstat.Text = "Desactivat";
                Grid.SetColumnSpan(lblEstat, 2);
                Grid.SetRow(lblEstat, i);
                gridInfo.Children.Add(lblEstat);
            }

            i++;
            gridResult.Children.Add(gridInfo);
        }

        //Tornem al menú ESTAT
        private void button1_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/Estat.xaml", UriKind.RelativeOrAbsolute));
        }

        //Tornem al menú PRINCIPAL
        private void button3_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.RelativeOrAbsolute));
        }
    }
}