﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using ClassesEntitats;

namespace UOC.SistemaControl.WCF
{
   

    public class Estat_wcf
    {
        private SistemaControlEntitats context;

        public Estat_wcf()
        {
            context = new SistemaControlEntitats();
        }

        public PlacaArduino InfoEstat(string seleccio)
        {
            int idAllotjament;
            string ipPlaca;
            PlacaArduino placa = new PlacaArduino();
            TipusAllotjament t = new TipusAllotjament();
            Allotjament a = new Allotjament();
            try
            {
                //Obtenim l'identificador de la selecció
                var q = (from p in context.TipusAllotjament where p.Descripcio == seleccio select p);
                t = q.FirstOrDefault<TipusAllotjament>();
                idAllotjament = t.idTipusAllotjament;

                //Obtenim IP de la Placa Arduino
                var q2 = (from p2 in context.Allotjament where p2.idAllotjament == idAllotjament select p2);
                a = q2.FirstOrDefault<Allotjament>();
                ipPlaca = a.IPPlaca;

                var q3 = (from p3 in context.PlacaArduino where p3.IPPlaca == ipPlaca select p3);
                placa = q3.FirstOrDefault<PlacaArduino>();


            }
            catch (Exception)
            {
                return null;
            }

            return placa;
        }

        public int ActivatPersianesId(int persiana)
        {
            int estat;
            DispositiuPersiana dp = new DispositiuPersiana();

            try
            {
                var q = (from p in context.DispositiuPersiana where p.idDispositiuPersiana == persiana select p);
                dp = q.FirstOrDefault<DispositiuPersiana>();
                estat = dp.NivellPersiana;
               
            }
            catch (Exception)
            {
                return 0;
            }
            return estat;
        }

        public int EstatSensorId(int sensor)
        {
            int estat;
            Sensors s = new Sensors();

            try
            {
                var q = (from p in context.Sensors where p.idSensor == sensor select p);
                s = q.FirstOrDefault<Sensors>();
                estat = s.Estat;
            }
            catch (Exception)
            {
                return 0;
            }
            return estat;
        }

        public int EstatIluminacioId(int dispositiu)
        {
            int estat;
            DispositiuIluminacio d = new DispositiuIluminacio();
            try
            {
                var q = (from p in context.DispositiuIluminacio where p.idDispositiuIluminacio == dispositiu select p);
                d = q.FirstOrDefault<DispositiuIluminacio>();
                estat = d.Estat;
            }
            catch (Exception)
            {
                return 0;
            }
            return estat;
        }
    }
}