﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;
using ClassesEntitats;

namespace UOC.SistemaControl.WCF
{
    // NOTA: puede usar el comando "Rename" del menú "Refactorizar" para cambiar el nombre de interfaz "IService1" en el código y en el archivo de configuración a la vez.
    [ServiceContract]
    public interface IService1
    {

        [OperationContract]
        string GetData(int value);

        [OperationContract]
        CompositeType GetDataUsingDataContract(CompositeType composite);

         /*
        * 
        * OPERACIONS DISPOSITIU IL·LUMINACIÓ
        * 
        */
        [OperationContract]
        int ObtenirEstatDispositiu(string disp);

        [OperationContract]
        int CanviEstatIluminacio(string disp, int estat);

        [OperationContract]
        List<DispositiuIluminacio> LlistaUbicacions();

        /*
         * 
         * OPERACIONS SENSORS
         * 
         */
        [OperationContract]
        List<string> LlistaSensors(string allotjament);

        [OperationContract]
        int EstatSensor(string sensor, string allotjament);

        [OperationContract]
        int CanviEstatSensors(string allotjament, string sensor, int estat);

        [OperationContract]
        List<string> SelectorUbicacio();    //No utiliztada

        [OperationContract]
        List<Sensors> SensorsUbicacio(string seleccio);

        /*
         * 
         * OPERACIONS DISPOSITIU PERSIANA
         * 
         */
        [OperationContract]
        int EstatActivat(string allotjament);

        [OperationContract]
        int EstatPersiana(string allotjament);

        [OperationContract]
        int CanviEstatPersiana(string allotjament, int estat);

        [OperationContract]
        int MovimentPersiana(string allotjament, int estat);

        [OperationContract]
        int NivellPersiana(string allotjament);

        [OperationContract]
        int CanviNivell(string allotjament, int niv);

        /*
        * 
        * OPERACIONS ESTAT
        * 
        */
        [OperationContract]
        PlacaArduino InfoEstat(string seleccio);

        [OperationContract]
        int ActivatPersianesId(int persiana);

        [OperationContract]
        int EstatSensorId(int sensor);

        [OperationContract]
        int EstatIluminacioId(int dispositiu);

        /*
        * 
        * OPERACIONS CONFIGURACIÓ
        * 
        */
        [OperationContract]
        Boolean ObtenirPassword(string pass);

        [OperationContract]
        int CanviPassword(string oldPass, string newPass);

        [OperationContract]
        Boolean ComprovaMail(string mail);

        [OperationContract]
        int CanviMail(string oldMail, string newMail);

        [OperationContract]
        string ObtenirMail();
       
    }
    }


    // Utilice un contrato de datos, como se ilustra en el ejemplo siguiente, para agregar tipos compuestos a las operaciones de servicio.
    [DataContract]
    public class CompositeType
    {
        bool boolValue = true;
        string stringValue = "Hello ";

        [DataMember]
        public bool BoolValue
        {
            get { return boolValue; }
            set { boolValue = value; }
        }

        [DataMember]
        public string StringValue
        {
            get { return stringValue; }
            set { stringValue = value; }
        }
    }

