﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using ClassesEntitats;

namespace UOC.SistemaControl.WCF
{
    public class Illuminacio_wcf
    {
        private SistemaControlEntitats context;

        public Illuminacio_wcf()
        {
            context = new SistemaControlEntitats();
        }

        public List<DispositiuIluminacio> LlistaUbicacions()
        {
            List<DispositiuIluminacio> llistaUbicacio = new List<DispositiuIluminacio>();

            try
            {
                var q = (from p in context.DispositiuIluminacio select p);
                llistaUbicacio = q.ToList<DispositiuIluminacio>();
            }
            catch (Exception)
            {
                return llistaUbicacio;
            }
            return llistaUbicacio;
        }

        public int ObtenirEstatDispositiu(string disp)
        {
            int estat;
            DispositiuIluminacio d = new DispositiuIluminacio();
            try
            {
                var q = (from p in context.DispositiuIluminacio where p.Descripcio == disp select p);
                d = q.FirstOrDefault<DispositiuIluminacio>();
                estat = d.Estat;

            }
            catch (Exception)
            {
                return 0;
            }

            return estat;
        }

        public int CanviEstatIluminacio(string disp, int estat)
        {
            int resultat;
            DispositiuIluminacio d = new DispositiuIluminacio();
            try
            {
                var q = (from p in context.DispositiuIluminacio where p.Descripcio == disp select p);
                d = q.FirstOrDefault<DispositiuIluminacio>();
                if (d.Estat == estat)
                {
                    resultat = 0;
                }
                else
                {
                    d.Estat = estat;
                    resultat = context.SaveChanges();
                }
            }
            catch (Exception)
            {
                return resultat = 0;
            }
            return resultat;
        }
    }
}