﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using ClassesEntitats;

namespace UOC.SistemaControl.WCF
{
    public class Persianes_wcf
    {
        private SistemaControlEntitats context;

        public Persianes_wcf()
        {
            context = new SistemaControlEntitats();
        }

        //Comprovem si el sensor esta activat
        public int EstatActivat(string seleccio)
        {
            int activat;

            DispositiuPersiana dp = new DispositiuPersiana();

            try
            {
                var q = (from p in context.DispositiuPersiana where p.Descripcio == seleccio select p);
                dp = q.FirstOrDefault<DispositiuPersiana>();
                activat = dp.Activat;
            }
            catch (Exception)
            {
                return 0;
            }
            return activat;
        }

        //Activar-Desactivar sensor
        public int CanviEstatPersiana(string seleccio, int estat)
        {
            DispositiuPersiana dp = new DispositiuPersiana();
            int resultat;

            try
            {
                var q = (from p in context.DispositiuPersiana where p.Descripcio == seleccio select p);
                dp = q.FirstOrDefault<DispositiuPersiana>();
                if (dp.Activat == estat)
                {
                    resultat = 0;
                }
                else
                {
                    dp.Activat = estat;
                    resultat = context.SaveChanges();
                }
            }
            catch (Exception)
            {
                return resultat = 0;
            }
            return resultat;
        }

        //Comprovem si esta en estat up, down o stop
        public int EstatPersiana(string seleccio)
        {
            DispositiuPersiana dp = new DispositiuPersiana();
            int estat;

            try
            {
                var q = (from p in context.DispositiuPersiana where p.Descripcio == seleccio select p);
                dp = q.FirstOrDefault<DispositiuPersiana>();
                estat = dp.Estat;
            }
            catch (Exception)
            {
                return estat = 0;
            }
            return estat;
        }

        //Canviem el moviment de la persiana (0=stop, 1=up, 2=down)
        public int MovimentPersiana(string seleccio, int estat)
        {
            DispositiuPersiana dp = new DispositiuPersiana();
            int resultat;

            try
            {
                var q = (from p in context.DispositiuPersiana where p.Descripcio == seleccio select p);
                dp = q.FirstOrDefault<DispositiuPersiana>();

                dp.Estat = estat;
                resultat = context.SaveChanges();
            }
            catch (Exception)
            {
                return 0;
            }
            return resultat;
        }

        //Obtenim el nivell d'obertura en el que esta la persiana
        public int Nivell(string seleccio)
        {
            DispositiuPersiana dp = new DispositiuPersiana();
            int nivell;

            try
            {
                var q = (from p in context.DispositiuPersiana where p.Descripcio == seleccio select p);
                dp = q.FirstOrDefault<DispositiuPersiana>();
                nivell = dp.NivellPersiana;
            }
            catch
            {
                return 0;
            }
            return nivell;
        }

        public int CanviNivell(string seleccio, int niv)
        {
            DispositiuPersiana dp = new DispositiuPersiana();

            try
            {
                var q = (from p in context.DispositiuPersiana where p.Descripcio == seleccio select p);
                dp = q.FirstOrDefault<DispositiuPersiana>();

                dp.NivellPersiana = niv;
                context.SaveChanges();
                return 1;
            }
            catch (Exception)
            {
                return 0;
            }

        }


    }
}