﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using ClassesEntitats;

namespace UOC.SistemaControl.WCF
{
    public class Sensors_wcf
    {
        private SistemaControlEntitats context;

        public Sensors_wcf()
        {
            context = new SistemaControlEntitats();
        }

        public List<string> SelectorUbicacio()
        {
            List<string> allotjament = new List<string>();
            try
            {
                var q = (from p in context.TipusAllotjament select p.Descripcio);
                allotjament = q.ToList();
            }
            catch (Exception)
            {
                return allotjament;
            }

            return allotjament;
        }

        public List<Sensors> SensorsUbicacio(string seleccio)
        {
            List<Sensors> s = new List<Sensors>();
            try
            {
                var q = (from p in context.Sensors where p.Ubicacio == seleccio select p);
                s = q.ToList<Sensors>();
            }
            catch (Exception)
            {
                return s;
            }
            return s;
        }

        //Llistem el diferents sensors corresponent a una ubicació de la casa
        public List<string> LlistaSensors(string allotjament)
        {
            List<string> sensors = new List<string>();
            try
            {
                var q = (from p in context.Sensors where p.Ubicacio == allotjament select p.Descripcio);
                sensors = q.ToList();
            }
            catch (Exception)
            {
                return sensors;
            }
            return sensors;
        }

        //Obtenim l'estat en que es troba el sensor de la ubicació indicada
        public int EstatSensor(string sensor, string allotjament)
        {
            int estat;

            try
            {
                var q = (from p in context.Sensors where p.Ubicacio == allotjament && p.Descripcio == sensor select p.Estat);
                estat = q.FirstOrDefault();
            }
            catch (Exception)
            {
                return 0;
            }
            return estat;
        }

        //Canviem l'estat del sensor 0=desactivat 1=activat

        public int CanviEstatSensor(string allotjament, string sensor, int estat)
        {
            Sensors s = new Sensors();
            int resultat;

            try
            {
                //Obtenim el sensor corresponent i l'activem o desactivem
                var q = (from p in context.Sensors where p.Ubicacio == allotjament && p.Descripcio == sensor select p);
                s = q.FirstOrDefault<Sensors>();
                if (s.Estat == estat)
                {
                    resultat = 0;
                }
                else
                {
                    s.Estat = estat;
                    resultat = context.SaveChanges();
                }
            }
            catch (Exception)
            {
                return resultat = 0;
            }
            return resultat;
        }
    }
}