﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;
using ClassesEntitats;

namespace UOC.SistemaControl.WCF
{
    // NOTA: puede usar el comando "Rename" del menú "Refactorizar" para cambiar el nombre de clase "Service1" en el código, en svc y en el archivo de configuración.
    public class Service1 : IService1
    {
        public string GetData(int value)
        {
            return string.Format("You entered: {0}", value);
        }

        public CompositeType GetDataUsingDataContract(CompositeType composite)
        {
            if (composite == null)
            {
                throw new ArgumentNullException("composite");
            }
            if (composite.BoolValue)
            {
                composite.StringValue += "Suffix";
            }
            return composite;
        }

        #region DIPS.IL·LUMINACIO


        public int ObtenirEstatDispositiu(String disp)
        {
            Illuminacio_wcf iluminacio = new Illuminacio_wcf();
            return iluminacio.ObtenirEstatDispositiu(disp);
        }

        public int CanviEstatIluminacio(string disp, int estat)
        {
            Illuminacio_wcf iluminacio = new Illuminacio_wcf();
            return iluminacio.CanviEstatIluminacio(disp, estat);
        }

        public List<DispositiuIluminacio> LlistaUbicacions()
        {
            Illuminacio_wcf iluminacio = new Illuminacio_wcf();
            return iluminacio.LlistaUbicacions();
        }
        #endregion

        #region PERSIANES
        public int EstatActivat(string allotjament)
        {
            Persianes_wcf persiana = new Persianes_wcf();
            return persiana.EstatActivat(allotjament);
        }

        public int CanviEstatPersiana(string allotjament, int estat)
        {
            Persianes_wcf persiana = new Persianes_wcf();
            return persiana.CanviEstatPersiana(allotjament, estat);
        }

        public int EstatPersiana(string seleccio)
        {
            Persianes_wcf persiana = new Persianes_wcf();
            return persiana.EstatPersiana(seleccio);
        }

        public int MovimentPersiana(string allotjament, int estat)
        {
            Persianes_wcf persiana = new Persianes_wcf();
            return persiana.MovimentPersiana(allotjament, estat);
        }

        public int NivellPersiana(string allotjament)
        {
            Persianes_wcf persiana = new Persianes_wcf();
            return persiana.Nivell(allotjament);
        }

        public int CanviNivell(string allotjament, int niv)
        {
            Persianes_wcf persiana = new Persianes_wcf();
            return persiana.CanviNivell(allotjament, niv);
        }
        #endregion

        #region SENSORS
        public List<string> SelectorUbicacio()
        {
            Sensors_wcf sensors = new Sensors_wcf();
            return sensors.SelectorUbicacio();
        }

        public List<Sensors> SensorsUbicacio(string seleccio)
        {
            Sensors_wcf sensors = new Sensors_wcf();
            return sensors.SensorsUbicacio(seleccio);
        }

        public List<string> LlistaSensors(string allotjament)
        {
            Sensors_wcf sensors = new Sensors_wcf();
            return sensors.LlistaSensors(allotjament);
        }

        public int EstatSensor(string sensor, string allotjament)
        {
            Sensors_wcf sensors = new Sensors_wcf();
            return sensors.EstatSensor(sensor, allotjament);
        }

        public int CanviEstatSensors(string allotjament, string sensor, int estat)
        {
            Sensors_wcf sensors = new Sensors_wcf();
            return sensors.CanviEstatSensor(allotjament, sensor, estat);
        }
        #endregion

        #region ESTAT
        public PlacaArduino InfoEstat(string seleccio)
        {
            Estat_wcf placa = new Estat_wcf();
            return placa.InfoEstat(seleccio);
        }

        public int EstatIluminacioId(int dispositiu)
        {
            Estat_wcf ilum = new Estat_wcf();
            return ilum.EstatIluminacioId(dispositiu);
        }

        public int ActivatPersianesId(int idPersiana)
        {
            Estat_wcf persiana = new Estat_wcf();
            return persiana.ActivatPersianesId(idPersiana);
        }

        public int EstatSensorId(int sensor)
        {
            Estat_wcf sensors = new Estat_wcf();
            return sensors.EstatSensorId(sensor);
        }
        #endregion

        #region CONFIGURACIO

        public Boolean ComprovaMail(string mail)
        {
            Configuracio_wcf u = new Configuracio_wcf();
            try
            {
                return u.ComprovaMail(mail);
            }
            catch (Exception)
            {
                return false;
            }
        }

        public int CanviMail(string oldMail, string newMail)
        {
            Configuracio_wcf u = new Configuracio_wcf();
            return u.CanviMail(oldMail, newMail);
        }

        public string ObtenirMail()
        {
            Configuracio_wcf u = new Configuracio_wcf();
            return u.ObtenirMail();
        }

        public Boolean ObtenirPassword(string pass)
        {
            Configuracio_wcf u = new Configuracio_wcf();
            try
            {
                return u.ObtenirPassword(pass);
            }
            catch (Exception)
            {
                return false;
            }
        }

        public int CanviPassword(string oldPass, string newPass)
        {
            Configuracio_wcf u = new Configuracio_wcf();
            return u.CanviPassword(oldPass, newPass);
        }
        #endregion
    }
}
