﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;


namespace UOC.SistemaControl.Web
{
    public partial class Configuracio : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        protected void AcceptaCanviPwd(object sender, EventArgs e)
        {
     
            string clau = newPassword.Text;
            int resultat = 0;
            ServiceReference1.Service1Client sr = new ServiceReference1.Service1Client();

            Boolean comproba = sr.ObtenirPassword(oldPassword.Text);


            /* Controlem que la clau actual es la mateixa que esta guardada actualment en la base de dades
            // Si es correcta, s'actualitza i es mostra una alerta per pantalla. Si es incorrecta la clau actual
            // o la clau nova, es mostra una alerta per pantalla i no s'actualitza.
            */
            if (comproba)
            {
                if (newPassword.Text.Length < 4)
                {
                    string script = @"<script type='text/javascript'>alerta('La clau nova a de tenir mínim 4 dígits');</script>";
                    ScriptManager.RegisterStartupScript(this, typeof(Page), "alerta", script, false);
                }
                else
                {
                    resultat = sr.CanviPassword(oldPassword.Text, clau);
                }
            }
            else
            {
                string script = @"<script type='text/javascript'>alerta('Clau actual incorrecta');</script>";
                ScriptManager.RegisterStartupScript(this, typeof(Page), "alerta", script, false);
            }

            if (resultat == 0)
            {
                string script = @"<script type='text/javascript'>alerta('Error al canviar la clau');</script>";
                ScriptManager.RegisterStartupScript(this, typeof(Page), "alerta", script, false);
            }
            else
            {
                string script = @"<script type='text/javascript'>alerta('Clau actualitzada');</script>";
                ScriptManager.RegisterStartupScript(this, typeof(Page), "alerta", script, false);
            }

        }

        //Si es cancel·la el canvi de clau, es buidan els camps de clau actual i clau nova
        protected void CancelaCanviPwd(object sender, EventArgs e)
        {
            newPassword.Text = "";
            oldPassword.Text = "";
        }

        protected void AcceptarMail_Click(object sender, EventArgs e)
        {
            string mail = newMail.Text;
            int resultat = 0;
            ServiceReference1.Service1Client sr = new ServiceReference1.Service1Client();

            Boolean comproba = sr.ComprovaMail(oldMail.Text);
            if (oldMail.Text != "" || newMail.Text != "")
            {
                try
                {
                    /* Controlem que el mail actual es la mateix que esta guardad actualment en la base de dades
                    // Si es correcte, s'actualitza i es mostra una alerta per pantalla. Si es incorrecte el mail actual
                    // o el mail nou, es mostra una alerta per pantalla i no s'actualitza.
                    */
                    if (comproba)
                    {
                        resultat = sr.CanviMail(oldMail.Text, mail);
                    }
                    else
                    {
                        string script = @"<script type='text/javascript'>alerta('Email actual incorrecte');</script>";
                        ScriptManager.RegisterStartupScript(this, typeof(Page), "alerta", script, false);
                    }

                    if (resultat == 0)
                    {
                        string script = @"<script type='text/javascript'>alerta('Error al canviar email');</script>";
                        ScriptManager.RegisterStartupScript(this, typeof(Page), "alerta", script, false);
                    }
                    else
                    {
                        string script = @"<script type='text/javascript'>alerta('Email actualitzat');</script>";
                        ScriptManager.RegisterStartupScript(this, typeof(Page), "alerta", script, false);
                    }
                }
                catch (Exception err)
                {
                    string script = @"<script type='text/javascript'>alerta('" + err.Message.ToString() + "');</script>";
                    ScriptManager.RegisterStartupScript(this, typeof(Page), "alerta", script, false);
                }
            }
            else
            {
                string script = @"<script type='text/javascript'>alerta('Introduir email');</script>";
                ScriptManager.RegisterStartupScript(this, typeof(Page), "alerta", script, false);
            }
            newMail.Text = "";
            oldMail.Text = "";
        }

        //Buidem els camps en cancel·lar l'acció
        protected void CancelarMail_Click(object sender, EventArgs e)
        {
            newMail.Text = "";
            oldMail.Text = "";
        }

    }
}