﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using UOC.SistemaControl.Web.ServiceReference1;

namespace UOC.SistemaControl.Web
{
    public partial class Estat : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        //Marquem com a index 0 del dropdownlist el Item "Selecciona Ubicació"
        //Aquest item sortirà per defecte com a primera opció
        protected void seleccio_DataBound(object sender, EventArgs e)
        {
            listAllotjament.Items.Insert(0, new ListItem("Selecciona Ubicació"));
        }

        //Seleccionem una ubicació de la casa per obtenir els estat dels sensors instal·lats
        protected void seleccionaUbicacio(object sender, EventArgs e)
        {
            if (listAllotjament.SelectedIndex > 0)
            {
                switch (listAllotjament.SelectedItem.ToString())
                {
                    case "Entrada":
                        Image2.ImageUrl = "../plano/entrada.gif";
                        Allotjament.Text = "Entrada";
                        ObtenirInformacio(listAllotjament.SelectedItem.ToString());
                        break;
                    case "Bany":
                        Image2.ImageUrl = "../plano/bano.gif";
                        Allotjament.Text = "Bany";
                        ObtenirInformacio(listAllotjament.SelectedItem.ToString());
                        break;
                    case "Cuina":
                        Image2.ImageUrl = "../plano/cocina.gif";
                        Allotjament.Text = "Cuina";
                        ObtenirInformacio(listAllotjament.SelectedItem.ToString());
                        break;
                    case "Dormitori":
                        Image2.ImageUrl = "../plano/dormitorio.gif";
                        Allotjament.Text = "Dormitori";
                        ObtenirInformacio(listAllotjament.SelectedItem.ToString());
                        break;
                    case "Saló":
                        Image2.ImageUrl = "../plano/salon.gif";
                        Allotjament.Text = "Saló";
                        ObtenirInformacio(listAllotjament.SelectedItem.ToString());
                        break;
                    case "Terrassa":
                        Image2.ImageUrl = "../plano/terraza.gif";
                        Allotjament.Text = "Terrassa";
                        ObtenirInformacio(listAllotjament.SelectedItem.ToString());
                        break;
                }
            }
            else
            {
                TaulaEstats.Visible = false;
                Allotjament.Text = "";
                Image2.ImageUrl = "~/plano/general.gif";
            }
        }

        //Llistem els sensors instal·lats a la ubicació seleccionada i mostrem el seu estat
        public void ObtenirInformacio(string seleccio)
        {

            ServiceReference1.Service1Client sr = new ServiceReference1.Service1Client();
            int estat;

            PlacaArduino placa = new PlacaArduino();
            placa = sr.InfoEstat(seleccio);

            if (placa.idDispositiuIluminacio != null)
            {
                estat = sr.EstatIluminacioId(placa.idDispositiuIluminacio.Value);
                OmplirTaula("Il·luminació", estat);
            }
            if (placa.idDispositiuPersiana != null)
            {
                estat = sr.ActivatPersianesId(placa.idDispositiuPersiana.Value);
                OmplirTaula("Persiana", estat);
            }
            if (placa.idSensorIncendi != null)
            {
                estat = sr.EstatSensorId(placa.idSensorIncendi.Value);
                OmplirTaula("Sensor Incendi", estat);
            }
            if (placa.idSensorInundacio != null)
            {
                estat = sr.EstatSensorId(placa.idSensorInundacio.Value);
                OmplirTaula("Sensor Inundació", estat);
            }
            if (placa.idSensorLlum != null)
            {
                estat = sr.EstatSensorId(placa.idSensorLlum.Value);
                OmplirTaula("Sensor Llum", estat);
            }
            if (placa.idSensorMagnètic != null)
            {
                estat = sr.EstatSensorId(placa.idSensorMagnètic.Value);
                OmplirTaula("Sensor Magnètic", estat);
            }
            if (placa.idSensorPresencia != null)
            {
                estat = sr.EstatSensorId(placa.idSensorPresencia.Value);
                OmplirTaula("Sensor Presència", estat);
            }
            if (placa.idSensorTemperatura != null)
            {
                estat = sr.EstatSensorId(placa.idSensorTemperatura.Value);
                OmplirTaula("Sensor Temperatura", estat);
            }

        }

        //Omplim la taula on es mostraran els sensors
        private void OmplirTaula(string descripcio, int estat)
        {

            //Afegim files noves amb dos celdes
            TableRow disp = new TableRow();
            TaulaEstats.Rows.Add(disp);
            TableCell Disp_sen = new TableCell();
            TableCell Estat_disp = new TableCell();
            Disp_sen.Text = descripcio;
            disp.Cells.Add(Disp_sen);
            if (descripcio == "Il·luminació" || descripcio == "Sensor Incendi" || descripcio == "Sensor Presència" || descripcio == "Sensor Inundació" || descripcio == "Sensor Magnètic")
            {
                if (estat == 1)
                {
                    Estat_disp.Text = "Activat";
                }
                else
                {
                    Estat_disp.Text = "Desactivat";
                }
            }
            if (descripcio == "Persiana")
            {
                Estat_disp.Text = estat.ToString() + "%";
            }
            if (descripcio == "Sensor Temperatura")
            {
                Estat_disp.Text = estat.ToString() + " °C";
            }
            if (descripcio == "Sensor Llum")
            {
                Estat_disp.Text = estat.ToString() + " Lux";
            }

            disp.Cells.Add(Estat_disp);

            //Propietats de les celdes
            Disp_sen.HorizontalAlign = HorizontalAlign.Left;
            Estat_disp.HorizontalAlign = HorizontalAlign.Right;
            Estat_disp.ForeColor = System.Drawing.Color.White;
            disp.Font.Size = 9;
        }
    }
}