﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace UOC.SistemaControl.Web
{
    public partial class Il_luminacio : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            
        }

        //Marquem com a index 0 del dropdownlist el Item "Selecciona Ubicació"
        //Aquest item sortirà per defecte com a primera opció
        protected void seleccio_DataBound(object sender, EventArgs e)
        {
            listDisp.Items.Insert(0, new ListItem("Selecciona Ubicació"));
        }

        //Seleccionem la ubicació de les llums que volem encendre
        protected void SeleccioUbicacio(object sender, EventArgs e)
        {

            int estat;
            ServiceReference1.Service1Client sr = new ServiceReference1.Service1Client();
            string seleccio = listDisp.SelectedItem.ToString();


            if (listDisp.SelectedIndex > 0)
            {
                Image1.Visible = true;
                switch (seleccio)
                {
                    case "Entrada":
                        Image2.ImageUrl = "../plano/entrada.gif";
                        estat = sr.ObtenirEstatDispositiu(seleccio); //Obtenim l'estat del dispositiu
                        IDispositiu(estat);
                        break;
                    case "Bany":
                        Image2.ImageUrl = "../plano/bano.gif";
                        estat = sr.ObtenirEstatDispositiu(seleccio);
                        IDispositiu(estat);
                        break;
                    case "Cuina":
                        Image2.ImageUrl = "../plano/cocina.gif";
                        estat = sr.ObtenirEstatDispositiu(seleccio);
                        IDispositiu(estat);
                        break;
                    case "Dormitori":
                        Image2.ImageUrl = "../plano/dormitorio.gif";
                        estat = sr.ObtenirEstatDispositiu(seleccio);
                        IDispositiu(estat);
                        break;
                    case "Saló":
                        Image2.ImageUrl = "../plano/salon.gif";
                        estat = sr.ObtenirEstatDispositiu(seleccio);
                        IDispositiu(estat);
                        break;
                    case "Terrassa":
                        Image2.ImageUrl = "../plano/terraza.gif";
                        estat = sr.ObtenirEstatDispositiu(seleccio);
                        IDispositiu(estat);
                        break;
                }
            }
            else
            {
                Image1.Visible = false;
                Label2.Text = "";
                Image2.ImageUrl = "~/plano/general.gif";
            }



        }

        //Activem la il·luminació. Si ja esta activada es mostrarà una alerta
        protected void Button1_activar(object sender, EventArgs e)
        {
            int resultat;
            int estat = 1;
            string seleccio = listDisp.SelectedItem.ToString();

            ServiceReference1.Service1Client sr = new ServiceReference1.Service1Client();
            resultat = sr.CanviEstatIluminacio(seleccio, estat);

            if (listDisp.SelectedIndex > 0)
            {
                if (resultat == 0)
                {
                    string script = @"<script type='text/javascript'>alerta('El dispositiu ja esta activat');</script>";
                    ScriptManager.RegisterStartupScript(this, typeof(Page), "alerta", script, false);
                }
                else
                {
                    IDispositiu(1);

                }
            }
            else
            {
                string script = @"<script type='text/javascript'>alerta('Selecciona Ubicació');</script>";
                ScriptManager.RegisterStartupScript(this, typeof(Page), "alerta", script, false);
            }
        }

        //Desactivem la il·luminació. Si ja esta desactivada es mostrarà una alerta
        protected void Button2_desactivar(object sender, EventArgs e)
        {
            int resultat;
            int estat = 0;
            string seleccio = listDisp.SelectedItem.ToString();

            ServiceReference1.Service1Client sr = new ServiceReference1.Service1Client();
            resultat = sr.CanviEstatIluminacio(seleccio, estat);

            if (listDisp.SelectedIndex > 0)
            {
                if (resultat == 0)
                {
                    string script = @"<script type='text/javascript'>alerta('El dispositiu ja esta desactivat');</script>";
                    ScriptManager.RegisterStartupScript(this, typeof(Page), "alerta", script, false);
                }
                else
                {
                    IDispositiu(0);

                }
            }
            else
            {
                string script = @"<script type='text/javascript'>alerta('Selecciona Ubicació');</script>";
                ScriptManager.RegisterStartupScript(this, typeof(Page), "alerta", script, false);
            }
        }

        //Mostrem imatge de l'estat de la il·luminació
        private void IDispositiu(int i)
        {
            if (i == 1)
            {
                Label2.Text = "Activat";
                Image1.ImageUrl = "../Images/activat.gif";
            }
            else
            {
                Label2.Text = "Desactivat";
                Image1.ImageUrl = "../Images/desactivat.gif";
            }
        }
    }
}