﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace UOC.SistemaControl.Web
{
    public partial class Persianes : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
                RadioButtonList1.ClearSelection();
        }

        //Marquem com a index 0 del dropdownlist el Item "Selecciona Ubicació"
        //Aquest item sortirà per defecte com a primera opció
        protected void seleccio_DataBound(object sender, EventArgs e)
        {
            listUbicacio.Items.Insert(0, new ListItem("Selecciona Ubicacio"));
        }

        //Selecció de la ubicació que volem controlar les persianes
        protected void seleccionaUbicacio(object sender, EventArgs e)
        {
            int estat;
            string seleccio = listUbicacio.SelectedItem.ToString();
            ServiceReference1.Service1Client sr = new ServiceReference1.Service1Client();
            Image3.Visible = true;
            Image1.Visible = true;

            if (listUbicacio.SelectedIndex > 0)
            {
                RadioButtonList1.ClearSelection();

                switch (seleccio)
                {
                    case "Saló":
                        Image2.ImageUrl = "../plano/salon.gif";
                        Image3.ImageUrl = "../Images/CameraSalo.jpg";
                        ProgressBar1.Value = sr.NivellPersiana(seleccio);
                        estat = sr.EstatActivat(seleccio);
                        if (estat == 1)
                        {
                            Image1.ImageUrl = "../Images/activat.gif";
                            lblEstat.Text = "Activat";
                        }
                        else
                        {
                            Image1.ImageUrl = "../Images/desactivat.gif";
                            lblEstat.Text = "Desactivat";
                        }
                        break;
                    case "Dormitori":
                        Image2.ImageUrl = "~/plano/dormitorio.gif";
                        Image3.ImageUrl = "../Images/CameraHabitacio.jpg";
                        ProgressBar1.Value = sr.NivellPersiana(seleccio);
                        estat = sr.EstatActivat(seleccio);
                        if (estat == 1)
                        {
                            Image1.ImageUrl = "../Images/activat.gif";
                            lblEstat.Text = "Activat";
                        }
                        else
                        {
                            Image1.ImageUrl = "../Images/desactivat.gif";
                            lblEstat.Text = "Desactivat";
                        }
                        break;
                }
            }
            else
            {
                ProgressBar1.Value = 0;
                RadioButtonList1.ClearSelection();
                Image1.Visible = false;
                Image3.Visible = false;
                lblEstat.Text = "";
                Image2.ImageUrl = "~/plano/general.gif";
            }

        }

        //Activem el pas de corrent per poder pujar i baixar la persiana
        //En el cas de que no hi hagi corrent no es podrà moure la persiana
        protected void Button1_activar(object sender, EventArgs e)
        {
            int resultat;
            int estat = 1;
            string seleccio = listUbicacio.SelectedItem.ToString();
            ServiceReference1.Service1Client sr = new ServiceReference1.Service1Client();
            resultat = sr.CanviEstatPersiana(seleccio, estat);

            if (listUbicacio.SelectedIndex > 0)
            {
                if (resultat == 0)
                {
                    string script = @"<script type='text/javascript'>alerta('El dispositiu esta connectat');</script>";
                    ScriptManager.RegisterStartupScript(this, typeof(Page), "alerta", script, false);

                }
                else
                {
                    lblEstat.Text = "Activat";
                    Image1.ImageUrl = "../Images/activat.gif";
                }
            }
            else
            {
                string script = @"<script type='text/javascript'>alerta('Selecciona Ubicació');</script>";
                ScriptManager.RegisterStartupScript(this, typeof(Page), "alerta", script, false);
            }
        }

        //Dispositiu persiana desconectat. No es podrà pujar ni baixar la persiana
        protected void Button2_desactivar(object sender, EventArgs e)
        {
            int resultat;
            int estat = 0;
            string seleccio = listUbicacio.SelectedItem.ToString();
            ServiceReference1.Service1Client sr = new ServiceReference1.Service1Client();
            resultat = sr.CanviEstatPersiana(seleccio, estat);

            if (listUbicacio.SelectedIndex > 0)
            {
                if (resultat == 0)
                {
                    string script = @"<script type='text/javascript'>alerta('El dispositiu esta desconnectat');</script>";
                    ScriptManager.RegisterStartupScript(this, typeof(Page), "alerta", script, false);
                }
                else
                {
                    lblEstat.Text = "Desactivat";
                    Image1.ImageUrl = "../Images/desactivat.gif";
                }
            }
            else
            {
                string script = @"<script type='text/javascript'>alerta('Selecciona Ubicació');</script>";
                ScriptManager.RegisterStartupScript(this, typeof(Page), "alerta", script, false);
            }
        }

        //Control del moviment de la persiana. Podrem pujar-la, baixar-la i parar-la
        protected void MovPersiana(object sender, EO.Web.ProgressTaskEventArgs e)
        {

            ServiceReference1.Service1Client sr = new ServiceReference1.Service1Client();
            string seleccio = listUbicacio.SelectedItem.ToString();
            int resultat, nivell;

            resultat = sr.EstatActivat(seleccio);


            if (RadioButtonList1.SelectedValue == "Pujar")
            {
                if (resultat == 1)
                {
                    sr.MovimentPersiana(seleccio, 1);
                    nivell = sr.NivellPersiana(seleccio);
                    for (int i = nivell; i <= 100; i++)
                    {
                        if (e.IsStopped)
                        {
                            sr.MovimentPersiana(seleccio, 0);
                            sr.CanviNivell(seleccio, i);
                            break;
                        }
                        if (i == 100)
                        {
                            sr.CanviNivell(seleccio, i);
                        }
                        System.Threading.Thread.Sleep(200);
                        e.UpdateProgress(i);

                    }
                    sr.MovimentPersiana(seleccio, 0);

                }

            }

            if (RadioButtonList1.SelectedValue == "Baixar")
            {
                if (resultat == 1)
                {
                    sr.MovimentPersiana(seleccio, 2);
                    nivell = sr.NivellPersiana(seleccio);
                    for (int i = nivell; i >= 0; i--)
                    {
                        if (e.IsStopped)
                        {
                            sr.MovimentPersiana(seleccio, 0);
                            sr.CanviNivell(seleccio, i);
                            break;
                        }
                        if (i == 0)
                        {
                            sr.CanviNivell(seleccio, i);
                        }
                        System.Threading.Thread.Sleep(200);
                        e.UpdateProgress(i);

                    }
                    sr.MovimentPersiana(seleccio, 0);

                }

            }
        }
    }
}