﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace UOC.SistemaControl.Web
{
    public partial class Sensors : System.Web.UI.Page
    {
        string sen;
        string tallotjament;

        protected void Page_Load(object sender, EventArgs e)
        {

        }

        //Marquem com a index 0 del dropdownlist el Item "Selecciona Ubicació"
        //Aquest item sortirà per defecte com a primera opció
        protected void seleccio_DataBound(object sender, EventArgs e)
        {
            listUbicacio.Items.Insert(0, new ListItem("Selecciona Ubicació"));
        }

        //Marquem com a index 0 del dropdownlist el Item "Selecciona Sensor"
        //Aquest item sortirà per defecte com a primera opció
        protected void seleccio_DataBound2(object sender, EventArgs e)
        {
            listSensor.Items.Insert(0, new ListItem("Selecciona Sensor"));
        }

        //Selecció de la ubicació de la que es vol obtenir els sensors
        protected void seleccioUbicacio(object sender, EventArgs e)
        {
            string seleccio = listUbicacio.SelectedItem.ToString();
            if (listUbicacio.SelectedIndex > 0)
            {
                switch (seleccio)
                {
                    case "Entrada":
                        Image2.ImageUrl = "../plano/entrada.gif";
                        ObtenirLlistaSensors(seleccio);
                        VisiblePlaceHolder();
                        break;
                    case "Bany":
                        Image2.ImageUrl = "../plano/bano.gif";
                        ObtenirLlistaSensors(seleccio);
                        VisiblePlaceHolder();
                        break;
                    case "Cuina":
                        Image2.ImageUrl = "../plano/cocina.gif";
                        ObtenirLlistaSensors(seleccio);
                        VisiblePlaceHolder();
                        break;
                    case "Dormitori":
                        Image2.ImageUrl = "../plano/dormitorio.gif";
                        ObtenirLlistaSensors(seleccio);
                        VisiblePlaceHolder();
                        break;
                    case "Saló":
                        Image2.ImageUrl = "../plano/salon.gif";
                        ObtenirLlistaSensors(seleccio);
                        VisiblePlaceHolder();
                        break;
                    case "Terrassa":
                        Image2.ImageUrl = "../plano/terraza.gif";
                        ObtenirLlistaSensors(seleccio);
                        VisiblePlaceHolder();
                        break;
                }
            }
            else
            {
                VisiblePlaceHolder();
                listSensor.Enabled = false;
            }

        }

        //Llistem els diferents sensors que estan instal·lats en la ubicació seleccionada
        private void ObtenirLlistaSensors(string seleccio)
        {
            ServiceReference1.Service1Client sr = new ServiceReference1.Service1Client();
            listSensor.Items.Clear();
            listSensor.Enabled = true;
            listSensor.DataSource = sr.LlistaSensors(seleccio);
            listSensor.DataBind();
        }

        //Seleccionem el sensor i obtenim l'estat en que es troben els sensors
        protected void seleccioSensor(object sender, EventArgs e)
        {
            ServiceReference1.Service1Client sr = new ServiceReference1.Service1Client();
            sen = listSensor.SelectedItem.ToString();
            tallotjament = listUbicacio.SelectedItem.ToString();

            if (listSensor.SelectedIndex > 0)
            {
                VisiblePlaceHolder();
                switch (sen)
                {
                    case "Sensor Llum":
                        SensorLlum.Visible = true;
                        infoEstat(sen, tallotjament);
                        break;
                    case "Sensor Presència":
                        Sensor_Presencia_Incendi_Inundacio.Visible = true;
                        infoEstat(sen, tallotjament);
                        break;
                    case "Sensor Incendi":
                        Sensor_Presencia_Incendi_Inundacio.Visible = true;
                        infoEstat(sen, tallotjament);
                        break;
                    case "Sensor Magnètic":
                        SensorMagnetic.Visible = true;
                        infoEstat(sen, tallotjament);
                        break;
                    case "Sensor Inundació":
                        Sensor_Presencia_Incendi_Inundacio.Visible = true;
                        infoEstat(sen, tallotjament);
                        break;
                    case "Sensor Temperatura":
                        SensorTemp.Visible = true;
                        infoEstat(sen, tallotjament);
                        break;
                }
            }
            else
            {
                VisiblePlaceHolder();
            }

        }

        //Obtenim l'estat dels sensors d'una zona de l'habitatge determinada
        protected void infoEstat(string sen, string tallotjament)
        {
            int estat = 0;
            ServiceReference1.Service1Client sr = new ServiceReference1.Service1Client();
            estat = sr.EstatSensor(sen, tallotjament);

            if (sen != "Sensor Llum" && sen != "Sensor Temperatura")
            {
                Estat(estat, sen);
            }
            else
            {
                if (sen == "Sensor Llum")
                {
                    llum.Text = Convert.ToString(estat);
                }
                if (sen == "Sensor Temperatura")
                {
                    TemperaturaC.Text = Convert.ToString(estat) + " °C";
                    TemperaturaF.Text = Convert.ToString(estat * 9 / 5 + 32) + " °F";
                }
            }
        }

        //Canviem la visibilitat dels PlaceHolder
        protected void VisiblePlaceHolder()
        {
            Sensor_Presencia_Incendi_Inundacio.Visible = false;
            SensorMagnetic.Visible = false;
            SensorLlum.Visible = false;
            SensorTemp.Visible = false;
        }

        //Botó per confirmar el canvi de sensibilitat del sensor de Llum
        protected void btn_confirmar(object sender, EventArgs e)
        {
            sen = listSensor.SelectedItem.ToString();
            tallotjament = listUbicacio.SelectedItem.ToString();
            ServiceReference1.Service1Client sr = new ServiceReference1.Service1Client();
            sr.CanviEstatSensors(tallotjament, sen, Convert.ToInt32(llum.Text));
            string script = @"<script type='text/javascript'>alerta('Actualitzat sensibilitat sensor llum');</script>";
            ScriptManager.RegisterStartupScript(this, typeof(Page), "alerta", script, false);
        }


        protected void Estat(int i, string sen)
        {
            Image3.Visible = true;
            Image4.Visible = true;

            if (i == 1)
            {
                Image4.ImageUrl = "../Images/activat.gif";
                Image3.ImageUrl = "../Images/activat.gif";
                lblEstat.Text = "Activat";
                lblEstat2.Text = "Activat";

                if (sen == "Sensor Incendi")
                    lblInfo.Text = "Detectat incendi!";
                if (sen == "Sensor Inundació")
                    lblInfo.Text = "Detectada inundació!";
                if (sen == "Sensor Magnètic")
                {
                    lblInfo3.ForeColor = System.Drawing.Color.Green;
                    if (tallotjament != "Entrada")
                    {
                        lblInfo2.Text = "Finestra: ";
                        lblInfo3.Text = "Oberta";
                    }
                    else
                    {
                        lblInfo2.Text = "Porta: ";
                        lblInfo3.Text = "Oberta";
                    }
                }
            }
            else
            {
                Image4.ImageUrl = "../Images/desactivat.gif";
                Image3.ImageUrl = "../Images/desactivat.gif";
                lblEstat.Text = "Desactivat";
                lblEstat2.Text = "Desactivat";

                if (sen == "Sensor Magnètic")
                {
                    lblInfo3.ForeColor = System.Drawing.Color.Red;

                    if (tallotjament != "Entrada")
                    {
                        lblInfo2.Text = "Finestra: ";
                        lblInfo3.Text = "Tancada";
                    }
                    else
                    {
                        lblInfo2.Text = "Porta: ";
                        lblInfo3.Text = "Tancada";
                    }

                }
            }
        }
    }
}