﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Net.Mail;
using UOC.SistemaControl.Web.ServiceReference1;

namespace UOC.SistemaControl.Web
{
    public partial class Simulador : System.Web.UI.Page
    {
        string seleccio;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                llum.Text = "600";
            }

        }

        //Marquem com a index 0 del dropdownlist el Item "Selecciona Ubicació"
        //Aquest item sortirà per defecte com a primera opció
        protected void llista_dataBound(object sender, EventArgs e)
        {
            llistaUbicacions.Items.Insert(0, new ListItem("Selecciona Ubicació"));
        }

        //Selecció de la ubicació
        protected void llistaUbicacions_SelectedIndexChanged(object sender, EventArgs e)
        {
            seleccio = llistaUbicacions.SelectedValue.ToString();


            if (llistaUbicacions.SelectedIndex > 0)
            {
                DesactivarButtons();
                BuidarEtiquetes();
                TancarPanells();

                switch (seleccio)
                {
                    case "Entrada":
                        Image2.ImageUrl = "../plano/vEntrada.gif";
                        EstatSensors(seleccio);
                        break;
                    case "Dormitori":
                        Image2.ImageUrl = "../plano/vDormitori.gif";
                        ObtenirTemperatura(seleccio);
                        EstatSensors(seleccio);
                        break;
                    case "Saló":
                        Image2.ImageUrl = "../plano/vSalo.gif";
                        ObtenirTemperatura(seleccio);
                        EstatSensors(seleccio);
                        break;
                    case "Cuina":
                        Image2.ImageUrl = "../plano/vCuina.gif";
                        ObtenirTemperatura(seleccio);
                        EstatSensors(seleccio);
                        break;
                    case "Bany":
                        Image2.ImageUrl = "../plano/vBany.gif";
                        ObtenirTemperatura(seleccio);
                        EstatSensors(seleccio);

                        break;
                    case "Terrassa":
                        Image2.ImageUrl = "../plano/vTerrassa.gif";
                        EstatSensors(seleccio);
                        break;

                }
            }
        }

        // Tanquem els Taulers d'opcions de cada sensor
        private void TancarPanells()
        {
            phFinestres.Visible = false;
            phPorta.Visible = false;
            phPresencia.Visible = false;
            phSLlum.Visible = false;
            phTemperatura.Visible = false;
            phInundacio.Visible = false;
            phIncendi.Visible = false;
        }

        //Obtenim l'estat de cada sensor, modifiquem el seu botó corresponent i mostrem el seu estat actual
        private void EstatSensors(string seleccio)
        {
            ServiceReference1.Service1Client sr = new ServiceReference1.Service1Client();
            int estat;

            PlacaArduino placa = new PlacaArduino();
            placa = sr.InfoEstat(seleccio);

            if (placa.idDispositiuIluminacio != null)
            {
                bPersona.Enabled = true;
                CanviColorBoto(bPersona);
                estat = sr.EstatIluminacioId(placa.idDispositiuIluminacio.Value);
                Label5.Text = DescripcioEstat(estat);
            }
            else
            {
                CanviColorBoto(bPersona);
            }
            if (placa.idSensorIncendi != null)
            {
                bIncendi.Enabled = true;
                CanviColorBoto(bIncendi);
                estat = sr.EstatSensorId(placa.idSensorIncendi.Value);
                Label9.Text = DescripcioEstat(estat);
            }
            else
            {
                CanviColorBoto(bIncendi);
            }
            if (placa.idSensorInundacio != null)
            {
                bInundacio.Enabled = true;
                CanviColorBoto(bInundacio);
                estat = sr.EstatSensorId(placa.idSensorInundacio.Value);
                Label18.Text = DescripcioEstat(estat);
            }
            else
            {
                CanviColorBoto(bInundacio);
            }
            if (placa.idSensorLlum != null)
            {
                bIluminacio.Enabled = true;
                CanviColorBoto(bIluminacio);
                estat = sr.EstatSensorId(placa.idSensorLlum.Value);
                Label20.Text = estat.ToString() + " Lux";
            }
            else
            {
                CanviColorBoto(bIluminacio);
            }
            if (placa.idSensorMagnètic != null)
            {
                if (seleccio == "Entrada")
                {
                    bPorta.Enabled = true;
                    CanviColorBoto(bPorta);
                    CanviColorBoto(bFinestra);
                }
                else
                {
                    bFinestra.Enabled = true;
                    CanviColorBoto(bFinestra);
                    CanviColorBoto(bPorta);
                }

                estat = sr.EstatSensorId(placa.idSensorMagnètic.Value);
                Label7.Text = DescripcioEstat(estat);
            }
            else
            {
                CanviColorBoto(bFinestra);
                CanviColorBoto(bPorta);
            }
            if (placa.idSensorPresencia != null)
            {
                bPersona.Enabled = true;
                CanviColorBoto(bPersona);
                estat = sr.EstatSensorId(placa.idSensorPresencia.Value);
                Label11.Text = DescripcioEstat(estat);

            }
            else
            {
                CanviColorBoto(bPersona);
            }
            if (placa.idSensorTemperatura != null)
            {
                bTemperatura.Enabled = true;
                CanviColorBoto(bTemperatura);
                estat = sr.EstatSensorId(placa.idSensorTemperatura.Value);
                Label13.Text = estat.ToString() + " °C";
            }
            else
            {
                CanviColorBoto(bTemperatura);
            }

        }

        //Mode present a casa
        protected void ActivarEstat_Click(object sender, EventArgs e)
        {
            DesSeg.Enabled = true;
            Session["seguretat"] = "Activada";
            if (sender.Equals(btnPresent))
            {
                Session["presencia"] = "Present";
                if (Page.IsValid)
                {
                    btnPresent.Enabled = false;
                    btnNoPresent.Enabled = true;
                }
            }
            else
            {
                Session["presencia"] = "Ausent";
                if (Page.IsValid)
                {
                    btnNoPresent.Enabled = false;
                    btnPresent.Enabled = true;
                }
            }
            llistaUbicacions.Enabled = true;
            upPanels.Update();

        }

        //Activem i desactivem la seguretat per al control d'obrir i tancar portes i/o finestres
        protected void Seguretat_Click(object sender, EventArgs e)
        {


            if (sender.Equals(ActSeg))
            {
                Session["seguretat"] = "Activada";
                if (Page.IsValid)
                {
                    ActSeg.Enabled = false;
                    DesSeg.Enabled = true;
                }
            }
            else
            {
                Session["seguretat"] = "Desactivada";
                if (Page.IsValid)
                {
                    ActSeg.Enabled = true;
                    DesSeg.Enabled = false;
                }
            }

        }

        //Descrivim l'estat d'un dispositiu i la alarma
        protected string DescripcioEstat(int i)
        {
            string estat;

            if (i == 1)
            {
                estat = "Activat";
            }
            else
            {
                estat = "Desactivat";
            }

            return estat;
        }

        //Actualitzem l'estat de l'alarma i sensors
        protected void StopAlarma_Click(object sender, EventArgs e)
        {
            if (lblEstatAlarma.Text == "Activada")
            {
                ServiceReference1.Service1Client sr = new ServiceReference1.Service1Client();
                lblEstatAlarma.Text = "Desactivada";

                if (Session["TipusAlarma"].ToString() == "Incendi")
                    sr.CanviEstatSensors(llistaUbicacions.SelectedValue.ToString(), "Sensor Incendi", 0);

                if (Session["TipusAlarma"].ToString() == "Inundacio")
                    sr.CanviEstatSensors(llistaUbicacions.SelectedValue.ToString(), "Sensor Inundació", 0);

                EstatSensors(llistaUbicacions.SelectedValue.ToString());
            }

        }

        ///////      COMPROVACIÓ SENSORS     //////       

        //Funció que obre una porta o finestra. Si l'usuari esta present en la casa
        //s'actualitza el sensor magnètic corresponent a la ubicació (Estat = 1)
        protected void Obrir_Click(object sender, EventArgs e)
        {
            ServiceReference1.Service1Client sr = new ServiceReference1.Service1Client();
            if (ActSeg.Enabled != true || DesSeg.Enabled != true)
            {
                if (Session["presencia"].ToString() == "Present")
                {
                    if (Session["seguretat"].ToString() == "Activada")
                    {
                        sr.CanviEstatSensors(llistaUbicacions.SelectedValue.ToString(), "Sensor Magnètic", 1);
                        lblEstatAlarma.Text = "Activada";

                    }
                    else
                    {
                        sr.CanviEstatSensors(llistaUbicacions.SelectedValue.ToString(), "Sensor Magnètic", 1);
                        sr.CanviEstatIluminacio(llistaUbicacions.SelectedValue.ToString(), 1);
                    }
                    sr.CanviEstatSensors(llistaUbicacions.SelectedValue.ToString(), "Sensor Presència", 1);

                }
                if (Session["presencia"].ToString() == "Ausent")
                {
                    if (Session["seguretat"].ToString() == "Activada")
                    {
                        string script = @"<script type='text/javascript'>alerta_portaFinestra('" + llistaUbicacions.SelectedValue.ToString() + "');</script>";
                        ScriptManager.RegisterStartupScript(this, typeof(Page), "alerta_portaFinestra", script, false);
                        sr.CanviEstatSensors(llistaUbicacions.SelectedValue.ToString(), "Sensor Magnètic", 1);
                        lblEstatAlarma.Text = "Activada";
                        enviarMail(System.DateTime.Now + ". Sensor Magnètic activat en " + llistaUbicacions.SelectedValue.ToString());
                    }
                    else
                    {
                        sr.CanviEstatSensors(llistaUbicacions.SelectedValue.ToString(), "Sensor Magnètic", 1);
                    }
                    sr.CanviEstatSensors(llistaUbicacions.SelectedValue.ToString(), "Sensor Presència", 1);
                }
            }

            btnPresencia.Enabled = false;
            btnPresencia2.Enabled = true;
            EstatSensors(llistaUbicacions.SelectedValue.ToString());
            Session["TipusAlarma"] = "Magnètic";
            if (Page.IsValid)
            {
                if (llistaUbicacions.SelectedValue.ToString() == "Entrada")
                {
                    TPorta.Enabled = true;
                    OPorta.Enabled = false;
                }
                else
                {
                    OFinestra.Enabled = false;
                    TFinestra.Enabled = true;
                }
            }
        }

        //Funció que tanca una porta o finestra. Modifica el seu estat (Estat = 0)
        protected void Tancar_Click(object sender, EventArgs e)
        {
            ServiceReference1.Service1Client sr = new ServiceReference1.Service1Client();
            sr.CanviEstatSensors(llistaUbicacions.SelectedValue.ToString(), "Sensor Magnètic", 0);
            EstatSensors(llistaUbicacions.SelectedValue.ToString());

            if (Page.IsValid)
            {
                if (llistaUbicacions.SelectedValue.ToString() == "Entrada")
                {
                    TPorta.Enabled = false;
                    OPorta.Enabled = true;
                }
                else
                {
                    OFinestra.Enabled = true;
                    TFinestra.Enabled = false;
                }
            }

        }

        //Consultar temperatura d'una ubicació determinada
        private void ObtenirTemperatura(string seleccio)
        {

            ServiceReference1.Service1Client sr = new ServiceReference1.Service1Client();
            PlacaArduino placa = new PlacaArduino();
            placa = sr.InfoEstat(llistaUbicacions.SelectedValue.ToString());
            Session["temp"] = sr.EstatSensorId(placa.idSensorTemperatura.Value);
            lblTemp.Text = Session["temp"] + " °C";
        }

        //Funció per canviar la temperatura de la ubicació
        protected void CanviTemperatura_Click(object sender, EventArgs e)
        {
            int i;
            i = Convert.ToInt32(Session["temp"].ToString());
            if (sender.Equals(PujarT))
            {
                if (i >= 0 && i < 30)
                {
                    i += 1;
                    lblTemp.Text = Convert.ToString(i) + " °C";
                    Session["temp"] = i;
                }
            }
            if (sender.Equals(BaixarT))
            {
                if (i > 0 && i <= 30)
                {
                    i -= 1;
                    lblTemp.Text = Convert.ToString(i) + " °C";
                    Session["temp"] = i;
                }
            }
        }

        //Funció que confirma el canvi de temperatura
        protected void ConfirmaTemperatura(object sender, EventArgs e)
        {
            ServiceReference1.Service1Client sr = new ServiceReference1.Service1Client();
            sr.CanviEstatSensors(llistaUbicacions.SelectedValue.ToString(), "Sensor Temperatura", Convert.ToInt32(Session["temp"].ToString()));
            EstatSensors(llistaUbicacions.SelectedValue.ToString());
        }

        //Activem la simulació d'incendi. Si l'usuari esta present s'activarà el sensor. 
        //Si l'usuari es troba ausent, es mostrarà una alerta i se li enviarà un email a l'usuari
        protected void SimulaIncendi_Click(object sender, EventArgs e)
        {
            ServiceReference1.Service1Client sr = new ServiceReference1.Service1Client();

            if (Session["presencia"].ToString() == "Present")
            {
                sr.CanviEstatSensors(llistaUbicacions.SelectedValue.ToString(), "Sensor Incendi", 1);

            }
            if (Session["presencia"].ToString() == "Ausent")
            {
                string script = @"<script type='text/javascript'>alerta('Sensor Incendi activat');</script>";
                ScriptManager.RegisterStartupScript(this, typeof(Page), "alerta", script, false);
                sr.CanviEstatSensors(llistaUbicacions.SelectedValue.ToString(), "Sensor Incendi", 1);

                enviarMail(System.DateTime.Now + ". Sensor d'Incendi activat en " + llistaUbicacions.SelectedValue.ToString());
            }
            lblEstatAlarma.Text = "Activada";
            Session["TipusAlarma"] = "Incendi";
            EstatSensors(llistaUbicacions.SelectedValue.ToString());
        }

        //Activem la simulació d'indundació. Si l'usuari esta present s'activarà el sensor. 
        //Si l'usuari es troba ausent, es mostrarà una alerta i se li enviarà un email a l'usuari
        protected void SimulaInundacio_Click(object sender, EventArgs e)
        {
            ServiceReference1.Service1Client sr = new ServiceReference1.Service1Client();


            if (Session["presencia"].ToString() == "Present")
            {
                sr.CanviEstatSensors(llistaUbicacions.SelectedValue.ToString(), "Sensor Inundació", 1);

            }
            if (Session["presencia"].ToString() == "Ausent")
            {
                string script = @"<script type='text/javascript'>alerta_inundacio('" + llistaUbicacions.SelectedValue.ToString() + "');</script>";
                ScriptManager.RegisterStartupScript(this, typeof(Page), "alerta", script, false);
                sr.CanviEstatSensors(llistaUbicacions.SelectedValue.ToString(), "Sensor Inundació", 1);
                enviarMail(System.DateTime.Now + ". Sensor d'Inundació activat en " + llistaUbicacions.SelectedValue.ToString());
            }

            lblEstatAlarma.Text = "Activada";
            Session["tipusAlarma"] = "Inundacio";
            EstatSensors(llistaUbicacions.SelectedValue.ToString());
        }

        //Activem la simulació de presència. Si l'usuari esta present s'activarà el sensor i es desactivarà als segons. 
        //Si l'usuari es troba ausent, es mostrarà una alerta i se li enviarà un email a l'usuari i per desactivar-ho
        //l'usuari haurà d'introduïr la contrasenya.
        protected void Presencia_Click(object sender, EventArgs e)
        {
            ServiceReference1.Service1Client sr = new ServiceReference1.Service1Client();

            if (ActSeg.Enabled != true || DesSeg.Enabled != true)
            {

                if (Session["presencia"].ToString() == "Present")
                {
                    if (sender.Equals(btnPresencia))
                    {
                        sr.CanviEstatIluminacio(llistaUbicacions.SelectedValue.ToString(), 1);
                        sr.CanviEstatSensors(llistaUbicacions.SelectedValue.ToString(), "Sensor Presència", 1);
                    }
                    else
                    {
                        sr.CanviEstatSensors(llistaUbicacions.SelectedValue.ToString(), "Sensor Presència", 0);
                        sr.CanviEstatIluminacio(llistaUbicacions.SelectedValue.ToString(), 0);
                    }
                }
                if (Session["presencia"].ToString() == "Ausent")
                {
                    if (sender.Equals(btnPresencia))
                        sr.CanviEstatSensors(llistaUbicacions.SelectedValue.ToString(), "Sensor Presència", 1);
                    else
                        sr.CanviEstatSensors(llistaUbicacions.SelectedValue.ToString(), "Sensor Presència", 0);
                }
            }

            EstatSensors(llistaUbicacions.SelectedValue.ToString());
            if (Page.IsValid)
            {
                if (sender.Equals(btnPresencia))
                {
                    btnPresencia.Enabled = false;
                    btnPresencia2.Enabled = true;
                }
                else
                {
                    btnPresencia2.Enabled = false;
                    btnPresencia.Enabled = true;
                }
            }
        }

        //Funció que depenen la llum que capti el sensor, activará les llums de la ubicació
        protected void SimularSensorLlum_Click(object sender, EventArgs e)
        {
            ServiceReference1.Service1Client sr = new ServiceReference1.Service1Client();
            int sensorLlum = sr.EstatSensor("Sensor Llum", llistaUbicacions.SelectedValue.ToString());
            if (Convert.ToInt32(llum.Text) < sensorLlum)
            {
                sr.CanviEstatIluminacio(llistaUbicacions.SelectedValue.ToString(), 1);
            }
            else
            {
                if (sr.ObtenirEstatDispositiu(llistaUbicacions.SelectedValue.ToString()) != 0)
                {
                    sr.CanviEstatIluminacio(llistaUbicacions.SelectedValue.ToString(), 0);
                }
            }
            EstatSensors(llistaUbicacions.SelectedValue.ToString());
        }

        //////////////////////////////////// FIR COMPROVACIÓ  ///////////////////////////

        //Tanquem tots els placeHolder del simulador i obrim el placeHolder corresponent al botó clickat
        protected void ObrirPH_Click(object sender, ImageClickEventArgs e)
        {
            TancarPanells();
            if (sender.Equals(bPersona))
                phPresencia.Visible = true;
            if (sender.Equals(bFinestra))
                phFinestres.Visible = true;
            if (sender.Equals(bPorta))
                phPorta.Visible = true;
            if (sender.Equals(bTemperatura))
                phTemperatura.Visible = true;
            if (sender.Equals(bIluminacio))
                phSLlum.Visible = true;
            if (sender.Equals(bIncendi))
                phIncendi.Visible = true;
            if (sender.Equals(bInundacio))
                phInundacio.Visible = true;
        }

        //Envia un email a la direcció de correu electronic de l'usuari
        private void enviarMail(String msg)
        {
            ServiceReference1.Service1Client sr = new ServiceReference1.Service1Client();

            string correu = sr.ObtenirMail();
            try
            {
                SmtpClient smtpServer = new SmtpClient("smtp.gmail.com");
                smtpServer.Port = 587;
                smtpServer.Credentials = new System.Net.NetworkCredential("sistemacontroldomotic@gmail.com", "lll73hx7");
                smtpServer.EnableSsl = true;

                MailMessage mail = new MailMessage();
                mail.From = new MailAddress("sistemadomotic@hotmail.com");
                mail.To.Add(new MailAddress(correu));

                mail.Subject = "Notificació SistemaControl";
                mail.Body = msg;
                mail.IsBodyHtml = true;

                smtpServer.Send(mail);
            }
            catch (Exception e)
            {
                string script = @"<script type='text/javascript'>alerta('" + e.ToString() + "');</script>";
                ScriptManager.RegisterStartupScript(this, typeof(Page), "alerta", script, false);
            }
        }

        //Funció per canviar la visibilitat dels botons dels sensors.
        //Si la ubicació disposa d'un sensor -> Opacity=100
        //Si la ubicació no disposa del sensor el botó -> Opacity=30
        protected void CanviColorBoto(ImageButton img)
        {
            if (!img.Enabled == true)
            {
                img.Style["background-color"] = "#000000";
                img.Style["filter"] = "alpha(opacity:30)";

            }
            else
                img.Style["filter"] = "alpha(opacity:100)";
        }

        //Buidem les etiquetes corresponents a l'estat de cada dispositiu
        private void BuidarEtiquetes()
        {
            Label5.Text = "";
            Label9.Text = "";
            Label18.Text = "";
            Label20.Text = "";
            Label7.Text = "";
            Label11.Text = "";
            Label13.Text = "";
        }

        //Desactivem els botons
        private void DesactivarButtons()
        {
            bPersona.Enabled = false;
            bPorta.Enabled = false;
            bTemperatura.Enabled = false;
            bFinestra.Enabled = false;
            bIncendi.Enabled = false;
            bInundacio.Enabled = false;
            bIluminacio.Enabled = false;
        }
    }
}